# Makefile template for genclasses
# $Id: Makefile.py,v 1.2 1996/05/06 07:33:56 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# Process this file with python to generate Makefile.in.

from pmg import *

m = komxxmakefile()

m.add_include("$(top_srcdir)/libconnection")
m.add_include("$(top_srcdir)/libkom++")
m.add_include("$(top_srcdir)/tcl-clients")

t = cxx_lib_target("genclass")

t.add_generated("Conf_no.Conf_stat.CHMap.o")
t.add_generated("Conf_no.Conf_stat.Map.o")
t.add_generated("Conf_no.get_conf_stat_question_ptr.CHMap.o")
t.add_generated("Conf_no.get_conf_stat_question_ptr.Map.o")
t.add_generated("Pers_no.Pers_stat.CHMap.o")
t.add_generated("Pers_no.Pers_stat.Map.o")
t.add_generated("Pers_no.get_person_stat_question_ptr.CHMap.o")
t.add_generated("Pers_no.get_person_stat_question_ptr.Map.o")
t.add_generated("Text_no.Text_stat.CHMap.o")
t.add_generated("Text_no.Text_stat.Map.o")
t.add_generated("Text_no.get_text_stat_question_ptr.CHMap.o")
t.add_generated("Text_no.get_text_stat_question_ptr.Map.o")
t.add_generated("Text_no.Set.o")
t.add_generated("Text_no.AVLSet.o")
t.add_generated("Local_text_no.Plex.o")
t.add_generated("Local_text_no.XPlex.o")
t.add_generated("Local_text_no.PQ.o")
t.add_generated("Local_text_no.XPPQ.o")
t.add_generated("Local_text_no.Set.o")
t.add_generated("Local_text_no.AVLSet.o")
t.add_generated("Conf_no.Text_mapping.CHMap.o")
t.add_generated("Conf_no.Text_mapping.Map.o")
t.add_generated("int.Command_table_ptr.CHMap.o")
t.add_generated("int.Command_table_ptr.Map.o")
t.add_generated("int.Membership.CHMap.o")
t.add_generated("int.Membership.Map.o")
t.add_generated("int.get_membership_question_ptr.CHMap.o")
t.add_generated("int.get_membership_question_ptr.Map.o")

m.add_target(t, "all")

generated_files = [
    "Conf_no.Conf_stat.CHMap.cc",
    "Conf_no.Conf_stat.CHMap.h",
    "Conf_no.Conf_stat.Map.cc",
    "Conf_no.Conf_stat.Map.h",
    "Conf_no.defs.h",
    "Conf_no.get_conf_stat_question_ptr.CHMap.cc",
    "Conf_no.get_conf_stat_question_ptr.CHMap.h",
    "Conf_no.get_conf_stat_question_ptr.Map.cc",
    "Conf_no.get_conf_stat_question_ptr.Map.h",
    "Pers_no.Pers_stat.CHMap.cc",
    "Pers_no.Pers_stat.CHMap.h",
    "Pers_no.Pers_stat.Map.cc",
    "Pers_no.Pers_stat.Map.h",
    "Pers_no.defs.h",
    "Pers_no.get_person_stat_question_ptr.CHMap.cc",
    "Pers_no.get_person_stat_question_ptr.CHMap.h",
    "Pers_no.get_person_stat_question_ptr.Map.cc",
    "Pers_no.get_person_stat_question_ptr.Map.h",
    "Text_no.Text_stat.CHMap.cc",
    "Text_no.Text_stat.CHMap.h",
    "Text_no.Text_stat.Map.cc",
    "Text_no.Text_stat.Map.h",
    "Text_no.defs.h",
    "Text_no.get_text_stat_question_ptr.CHMap.cc",
    "Text_no.get_text_stat_question_ptr.CHMap.h",
    "Text_no.get_text_stat_question_ptr.Map.cc",
    "Text_no.get_text_stat_question_ptr.Map.h",
    "Text_no.Set.cc",
    "Text_no.Set.h",
    "Text_no.AVLSet.cc",
    "Text_no.AVLSet.h",
    "Local_text_no.XPlex.cc",
    "Local_text_no.XPlex.h",
    "Local_text_no.Plex.cc",
    "Local_text_no.Plex.h",
    "Local_text_no.PQ.cc",
    "Local_text_no.PQ.h",
    "Local_text_no.XPPQ.cc",
    "Local_text_no.XPPQ.h",
    "Local_text_no.defs.h",
    "Local_text_no.Set.cc",
    "Local_text_no.Set.h",
    "Local_text_no.AVLSet.cc",
    "Local_text_no.AVLSet.h",
    "Conf_no.Text_mapping.CHMap.cc",
    "Conf_no.Text_mapping.CHMap.h",
    "Conf_no.Text_mapping.Map.cc",
    "Conf_no.Text_mapping.Map.h",
    "int.Command_table_ptr.CHMap.cc",
    "int.Command_table_ptr.CHMap.h",
    "int.Command_table_ptr.Map.cc",
    "int.Command_table_ptr.Map.h",
    "int.Membership.CHMap.cc",
    "int.Membership.CHMap.h",
    "int.Membership.Map.cc",
    "int.Membership.Map.h",
    "int.get_membership_question_ptr.CHMap.cc",
    "int.get_membership_question_ptr.CHMap.h",
    "int.get_membership_question_ptr.Map.cc",
    "int.get_membership_question_ptr.Map.h",
    "int.defs.h"]

for f in generated_files:
    m.add_target(generated_source(f), "source")

m.emit()

print """
include $(srcdir)/Conf_no.get_conf_stat_question_ptr.CHMap.make
include $(srcdir)/Conf_no.Conf_stat.CHMap.make
include $(srcdir)/Conf_no.defs.make
include $(srcdir)/Pers_no.get_person_stat_question_ptr.CHMap.make
include $(srcdir)/Pers_no.Pers_stat.CHMap.make
include $(srcdir)/Pers_no.defs.make
include $(srcdir)/Text_no.get_text_stat_question_ptr.CHMap.make
include $(srcdir)/Text_no.Text_stat.CHMap.make
include $(srcdir)/Text_no.defs.make
include $(srcdir)/Text_no.AVLSet.make
include $(srcdir)/Local_text_no.AVLSet.make
include $(srcdir)/Local_text_no.XPPQ.make
include $(srcdir)/Local_text_no.defs.make
include $(srcdir)/Conf_no.Text_mapping.CHMap.make
include $(srcdir)/int.Command_table_ptr.CHMap.make
include $(srcdir)/int.Membership.CHMap.make
include $(srcdir)/int.get_membership_question_ptr.CHMap.make
include $(srcdir)/int.defs.make
"""
