# Makefile for libconnection
# $Id: Makefile.py,v 1.2 1996/05/06 07:34:30 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# Process this file with python to generate Makefile.in.

from pmg import *
m = komxxmakefile()

m.add_include("$(top_srcdir)/libkom++")
m.add_include("../genclasses")
m.add_include("$(top_srcdir)/libisc/src")
m.add_include("$(top_srcdir)/libcompat")

t = cxx_lib_target("connection")
t.add("connection.o")
t.add("question.o")
t.add("async.o")
t.add("async_text_created.o")
t.add("async_text_message.o")
t.add("async_dispatcher.o")
t.add("000login_old_q.o")
t.add("001logout_q.o")
t.add("002pepsi_q.o")
t.add("003change_name_q.o")
t.add("004change_what_i_am_doing_q.o")
t.add("005create_person_q.o")
t.add("008set_passwd_q.o")
t.add("009get_membership_q.o")
t.add("010create_conf_q.o")
t.add("011delete_conf_q.o")
t.add("012lookup_name_q.o")
t.add("014add_member_q.o")
t.add("015sub_member_q.o")
t.add("016set_presentation_q.o")
t.add("017set_etc_motd_q.o")
t.add("018set_supervisor_q.o")
t.add("019set_permitted_submitters_q.o")
t.add("020set_super_conf_q.o")
t.add("021set_conf_type_q.o")
t.add("022set_garb_nice_q.o")
t.add("023get_marks_q.o")
t.add("024mark_text_old_q.o")
t.add("025get_text_q.o")
t.add("026get_text_stat_q.o")
t.add("027mark_as_read_q.o")
t.add("028create_text_q.o")
t.add("029delete_text_q.o")
t.add("030add_recipient_q.o")
t.add("031sub_recipient_q.o")
t.add("032add_comment_q.o")
t.add("033sub_comment_q.o")
t.add("034get_map_q.o")
t.add("035get_time_q.o")
t.add("036get_info_q.o")
t.add("037add_footnote_q.o")
t.add("038sub_footnote_q.o")
t.add("040set_unread_q.o")
t.add("042enable_q.o")
t.add("043sync_q.o")
t.add("044shutdown_q.o")
t.add("049get_person_stat_q.o")
t.add("050get_conf_stat_q.o")
t.add("051who_is_on_q.o")
t.add("052get_unread_confs_q.o")
t.add("053send_message_q.o")
t.add("055disconnect_q.o")
t.add("056who_am_i_q.o")
t.add("057set_user_area_q.o")
t.add("058get_last_text_q.o")
t.add("059create_anonymous_text_q.o")
t.add("060find_next_text_no_q.o")
t.add("061find_previous_text_no_q.o")
t.add("062login_q.o")
t.add("065re_lookup_person_q.o")
t.add("069set_client_version_q.o")
t.add("070get_client_name_q.o")
t.add("071get_client_version_q.o")
t.add("072mark_text_q.o")
t.add("073unmark_text_q.o")
t.add("076lookup_z_name_q.o")

m.add_target(t, "all")

m.emit()
