# Makefile for libkom++
# $Id: Makefile.py,v 1.3 1996/05/06 07:35:24 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# Process this file with python to generate Makefile.in.

from pmg import *
m = komxxmakefile()

m.add_include("../genclasses")
m.add_include("$(top_srcdir)/libconnection")
m.add_include("$(top_srcdir)/libisc/src")
m.add_include("$(top_srcdir)/libcompat")

t = cxx_lib_target("kom++")

t.add("Local2Global.o")
t.add("LyStr.o")
t.add("array.o")
t.add("conf-cache.o")
t.add("conf-stat.o")
t.add("conf-z-info.o")
t.add("conference.o")
t.add("fetchable.o")
t.add("kom-error.o")
t.add("map-cache.o")
t.add("maps.o")
t.add("mark.o")
t.add("membership-cache.o")
t.add("membership.o")
t.add("memcheck.o")
t.add("micro-conf.o")
t.add("misc.o")
t.add("pers-cache.o")
t.add("pers-stat.o")
t.add("person.o")
t.add("prot-a-LyStr.o")
t.add("read-order.o")
t.add("recipient.o")
t.add("server-info.o")
t.add("session.o")
t.add("small-types.o")
t.add("text-cache.o")
t.add("text-mapping.o")
t.add("text-mass-cache.o")
t.add("text-stat.o")
t.add("text.o")
t.add("unread-confs.o")
t.add("uplink.o")
t.add("who-info.o")

m.add_target(t, "all")

m.add_target(generated_source("stamp-enabler"), "source")
m.clean("memcheck-enabler.h")

m.emit()

print "MEMCHECK_yes_VALUE=1"
print "MEMCHECK_no_VALUE=0"
print "stamp-enabler: Makefile"
print "\t$(RM) memcheck-enabler.tmp"
print "\techo // Automatically generated -- do not edit >>memcheck-enabler.tmp"
print "\techo '#define' ENABLE_MEMCHECK $(MEMCHECK_@USE_MEMCHECK@_VALUE)",
print ">>memcheck-enabler.tmp"
print "\tif cmp memcheck-enabler.tmp memcheck-enabler.h >/dev/null 2>&1; \\"
print "\tthen $(RM) memcheck-enabler.tmp; \\"
print "\telse mv -f memcheck-enabler.tmp memcheck-enabler.h; \\"
print "\tfi"
print "\ttouch stamp-enabler"
