// A simple template array class.
//
// $Id: array.h,v 1.8 1995/11/14 06:50:05 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef KOMXX_ARRAY_H
#define KOMXX_ARRAY_H

#include <stream.h>

template <class T>
class Array {
  private:
    long   len;
    T    * arr;

  public:
    Array(long size = 0);
    Array(const Array &a);
    ~Array();

    const Array & operator = (const Array &a);

    void set_size(long size);

    long size() const;
    T &operator[](long i) const;
    void set(long i, T t);

    void push_back(const T &elem);

    // friends:
    friend ostream &operator <<(ostream &str, const Array<T> &a);
};

#ifndef OUTLINE
#include "array.icc"
#endif

#endif
