// Create-on-demand map of mappings for conferences.
//
// $Id: maps.h,v 1.5 1995/11/14 00:35:21 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef KOMXX_MAPS_H
#define KOMXX_MAPS_H

#include "kom-types.h"

class Conferences;
class Conf_cache;
class Connection;
class Map_cache;
class Text_mapping;

class Maps {
  public:
    Maps(const Conferences&, Async_dispatcher *async_disp);
    ~Maps();

    Maps & operator = (const Maps &);
    Connection *connection() const;
    
    Text_mapping operator[](Conf_no) const;

    Map_cache * read_map_cache() const;

  private:
    Map_cache *cache;
};
#endif
