// String class with knowledge on protocol A.
//
// $Id: prot-a-LyStr.cc,v 1.5 1995/11/14 06:06:43 ceder Exp $
// Copyright (C) 1994  Per Cederqvist and Inge Wallin
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <assert.h>
#include <ctype.h>
#include "prot-a-LyStr.h"

prot_a_LyStr::prot_a_LyStr() 
{ 
}

prot_a_LyStr::prot_a_LyStr(const char *c_str)
    : LyStr(c_str)
{
}

prot_a_LyStr::prot_a_LyStr(void *block, int len)
    : LyStr(block, len)
{
}

prot_a_LyStr::prot_a_LyStr(const prot_a_LyStr &l)
    : LyStr(l)
{
}

prot_a_LyStr::prot_a_LyStr(const LyStr &l)
    : LyStr(l)
{
}


// ================================================================


long
prot_a_LyStr::stol()
{
    // +++ Better error handling needed here.
    long res = 0;
    int i = 0;

    while (i < used && operator[](i) == ' ')
	i++;

    while(i < used && isdigit(operator[](i)))
    {
	res *= 10;
	res += operator[](i++) - '0';
    }

    remove_first(i);
    return res;
}

LyStr
prot_a_LyStr::stos()
{
    long len = stol();
    assert (operator[](0) == 'H');
    remove_first(1);
    LyStr res = substr(len);
    remove_first(len);
    return res;
}

void
prot_a_LyStr::append_hollerith(const LyStr &str)
{
    *this << str.strlen() << 'H' << str;
}


int
prot_a_LyStr::parse_array_start()
{
    int   size;

    size = stol();
    if (size > 0)
    {
	skipspace();
	if (strlen() > 0 && operator[](0) == '{')
	    remove_first(1);
    }
    
    return size;
}


void
prot_a_LyStr::parse_array_end(int arrsize)
{
    skipspace();
    if (arrsize < 0)
	return;
    else if (arrsize == 0) {
	if (strlen() > 0) {
	    if (operator[](0) == '*')
		remove_first(1);
	}
    } else {
	if (strlen() > 0) {
	    if (operator[](0) == '}')
		remove_first(1);
	}
    }
}


void
prot_a_LyStr::append_array_start(int arrsize)
{
    *this << arrsize << " {";
}


void
prot_a_LyStr::append_array_end()
{
    *this <<  "} ";
}
