# Makefile template for WWW-kom
# $Id: Makefile.py,v 1.2 1996/05/06 07:45:31 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# Process this file with python to generate Makefile.in.

from pmg import *

class htmldir_mixin(bindir_mixin):
    def destination(self):
	return "$(htmldir)"

class html_files(htmldir_mixin, collection_target):
    def __init__(self):
	self.name = "html"
	collection_target.__init__(self)

    def add(self, object):
	self.add_dep(item(object))


class gif_files(htmldir_mixin, collection_target):
    def __init__(self):
	self.name = "gif"
	collection_target.__init__(self)

    def add(self, object):
	self.add_dep(item(object))

m = komxxmakefile()

t = html_files()
t.add("index.html")
t.add("newuser.html")
t.add("nyheter.html")

m.add_target(t)

t = gif_files()
t.add("home.gif")
t.add("next.gif")
t.add("signum.gif")
t.add("wwwkom.gif")
t.add("comment.gif")
t.add("exit.gif")
t.add("board.gif")
t.add("write.gif")
t.add("selconf.gif")

m.add_target(t)

m.emit()

print """\
# Where to install HTML files
htmldir = $(datadir)/wwwkom/$(VERSION)/html
"""
