# $Id: language.py,v 1.9 1996/05/08 07:51:45 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import string
import pickle
import komhtml

# Set by sc.  This module uses toolbar.at_top() and toolbar.at_bottom()
# to extract the tool bar.
toolbar = None

TEXT_FORMAT = """%(text_no)d %(creation_date)s /%(lines)s/ %(author)s<br>
%(recipients)s%(uplinks)s%(marks)s
<h3>rende: %(subject)s</h3>

%(body)s

<p>%(footnotes)s%(comments)s
"""

COMMENT_FORMAT = """Kommentera text %(parent_link)s av %(parent_author)s

<p><form action="submit_comment" method=get>
<input type="hidden" name="parent" value="%(parent)s">
<input type="hidden" name="known_comments" value="%(known_comments)s">
Konvertering av text:<br>
<input type="radio" name="conversion" 
	value="swascii" %(select_swascii)s>frn swascii<br>
<input type="radio" name="conversion"
	value="none" %(select_none)s>ingen<br>
Mottagare: (ta bort en mottagare frn listan genom att vlja bort den)<br>
<input type="hidden" name="no_of_rcpts" value="%(no_of_rcpts)s">
%(recipients)s

<p><input type="submit" value="Skapa kommentaren">

<p><input type="text" name="subject" value="%(subject)s" size=70>
<textarea name="body" rows="15" cols="70">%(body)s</textarea>

<p><input type="submit" value="Skapa kommentaren">
</form>
"""

WRITE_TEXT_FORMAT = """

<p><form action="submit_text" method=get>
Konvertering av text:<br>
<input type="radio" name="conversion" 
	value="swascii" %(select_swascii)s>frn swascii<br>
<input type="radio" name="conversion"
	value="none" %(select_none)s>ingen<br>
Mottagare: (ta bort en mottagare frn listan genom att vlja bort den)<br>
<input type="hidden" name="no_of_rcpts" value="%(no_of_rcpts)s">
%(recipients)s

<p><input type="submit" value="Skapa texten">

<p><input type="text" name="subject" value="%(subject)s" size=70>
<textarea name="body" rows="15" cols="70">%(body)s</textarea>

<p><input type="submit" value="Skapa texten">
</form>
"""

NEW_TEXTS_INFO = """\
Sedan du brjade frfatta din kommentar har det skapats minst en
ny kommentar.  gna igenom de nya texterna nedan.  Om du fortfarande
tycker att din kommentar r relevant kan du klicka p
"Skapa kommentaren"-knappen (lngst ner p sidan) fr att skicka in
texten igen.  Om du mrker att ngon annan redan har sagt det du hade
tnkt sga r det kanske ingen strre vits med att du upprepar samma
sak en gng till.  I s fall kan du g tillbaks och fortstta lsa.
<p>

<i>Default_url</i>

<hr><blockquote>
"""

NEW_TEXTS_INFO_TAIL = "</blockquote><hr>"

KILLED = """\
Din sessionshanterare r nu avslutad.  Du r utloggad ur LysKOM.
Observera dock att din WWW-klient troligtvis fortfarande innehller
ditt LysKOM-anvndarnamn och lsenord.  Fr att skerstlla att
ingen obehrigt anvnder LysKOM i ditt namn br du starta om din
WWW-klient innan du lmnar datorn.

<p>Du kan starta en ny session genom att vlja ngot av alternativen ovan.
"""

SELECT_CONF_FORM = """\
<form action="submit_select_conf" method=get>
Namn: <input type="text" name="conf_name" size=70>
<input type="submit" value="Sk"><br>
Vad ska matchas?<br>
<input type="radio" name="domain" value="conf" checked selected>Enbart mten<br>
<input type="radio" name="domain" value="pers">Enbart personer<br>
<input type="radio" name="domain" value="both">Bde personer och mten<br>
</form>

<p>I rutan efter "Namn" kan du fylla i ett mtes- eller personnamn.
Du kan frkorta namnet genom att utelmna ord p slutet, och genom att
utelmna bokstver p slutet i ord.  Om mer n ett mte matchar det
frkortade mtesnamnet du angivit kommer du att f upp en lista med
dem, dr du kan vlja rtt.

<p>Om du lmnar rutan tom kommer alla mten att returneras.  Det kan
ta ett bra tag.

<p>Du kan vlja om du vill ska bland mten, personer eller bde och.
"""

CONF_STAT = """\
Status fr mte "%(name)s":

<ul>
<li>Skapat av %(creator)s
<li>Organisatr: %(supervisor)s
<li>Tilltna frfattare: %(permitted_submitters)s
<li>Presentation: %(presentation)s
</ul>

<a href="%(join)s">G med i mtet</a><br>
<a href="%(write_text)s">Skriva ett inlgg</a><br>
"""

class pages:
   def list_conf_z_info(self, list, urlformat):
      res="<ul>\n"
      for item in list:
	 cno = item.conf_no()
	 url = urlformat % cno
	 res = (res + '<li><a href="' + url
		+ ('">%s</a>\n' % komhtml.htmlquote(item.conf_name())))
      res = res + "</ul>\n\n"
      return res

   def page(self, title, header, body):
      if toolbar:
	 top_tool = toolbar.at_top()
	 bot_tool = toolbar.at_bottom()
      else:
	 top_tool = ""
	 bot_tool = ""
      return ("<html><head><title>" + self.title(title)
	      + "</title></head>\n<body><h1>"
	      + header + "</h1>\n\n" + top_tool + body + bot_tool + "\n\n"
	      + self.stdfoot() + "</body>")


class sw_pages(pages):
   def stdfoot(self):
      return ("<hr>"
	      + komhtml.icon("wwwkom.gif", "WWW-koms hemsida", "/")
	      + komhtml.icon("signum.gif", "Signum Support AB",
			     "http://www.signum.se/")
	      + 'WWW-kom. Copyright (C) 1996 Signum Support AB\n')

   def title(self, t):
      return "LysKOM: " + t
   
   def ambiguous_login(self, given, matches):
      return self.page("Vem r du?", "Vem r du?",
		       "Det namn du angav, \"" + komhtml.htmlquote(given)
		       + "\", kan vara ngon av fljande personer:\n"
		       + self.list_conf_z_info(matches,
					       komhtml.komurl("%s", "login")))

   def session_redirect(self, newurl):
      return self.page("Omstyrning", "Omstyrning",
		       "Det namn du angett stmmer inte med den URL du angett "
		       + " \r\nEn korrekt URL fr det angivna namnet r\r\n"
		       + '<a href="' + newurl + '">' + newurl + '</a>. '
		       + "<p>Om din Web-lsare hade frsttt felkod 301 hade "
		       + "du inte sett det hr meddelandet")

   def who_is_on(self, wholist):
       header = "<table border=0 cellpadding=3>"
       footer = "</table><p><h3>Sammanlagt " + `len(wholist)` + " personer</h3>"

       wholiststring = string.join(wholist, "\n")
       return self.page("Inloggade i lyskom",
			"Fljande personer r inloggade fr nrvarande",
			header + wholiststring + footer)

   def not_present(self):
       return "Ej nrvarande i ngot mte"

   def format_footnote(self, footnote, footnote_author):
      return ("Kommentar i text " + footnote + " av " + footnote_author
	      + "<br>\n")

   def format_comment(self, comment, comment_author):
      return ("Kommentar i text " + comment + " av " + comment_author
	      + "<br>\n")

   def format_date(self, date):
      return "%04d-%02d-%02d %02d:%02d:%02d" % date[0:6]
      return `date[0]` + "-" + `date[1]` + "-" + `date[2]` \
	     + " " + `date[3]` + ":" + `date[4]` + ":" + `date[5]`

   def format_uplink(self, is_footnote, parent_text, parent_author_name,
		     sent_at, sender_name):
      if is_footnote:
	 res = "Fotnot till text "
      else:
	 res = "Kommentar till text "
      res = res + parent_text + " av " + parent_author_name + "<br>\n"
      if sent_at:
	 res = (res + "&nbsp;&nbsp;Snt: " + self.format_date(sent_at)
		+ "<br>\n")
      if sender_name:
	 res = res + "&nbsp;&nbsp;Snt av: " + sender_name + "<br>\n"
      return res

   def undef_conf(self, conf_no):
      return "Person/mte nummer " + `conf_no` + " (existerar ej/hemlig)"

   def nonexisting_text(self):
      return " (ej lsbar av dig)"

   def nonexisting_text_long(self):
      return "Texten finns inte, eller ocks r den hemlig."

   def anonymous_author(self):
      return " (anonym frfattare)"

   def nonexistent_author(self, pers_no):
      return " (utplnad/hemlig frfattare nummer " + `pers_no` + ")"

   def format_recipient(self, is_carbon_copy, name, local_no,
			rec_time, sent_time, sender_name):
      if is_carbon_copy:
	 res = "Extra kopiemottagare "
      else:
	 res = "Mottagare "
      res = res + name + " &lt;" + `local_no` + "&gt;<br>\n"
      if rec_time:
	 res = (res + "&nbsp;&nbsp;Mottaget: " + self.format_date(rec_time)
		+ "<br>\n")
      if sent_time:
	 res = (res + "&nbsp;&nbsp;Snt: " + self.format_date(sent_time)
		+ "<br>\n")
      if sender_name:
	 res = res + "&nbsp;&nbsp;Snt av: " + sender_name + "<br>\n"
      return res

   def text_rewrite_map(self, map):
      if map["lines"] == 1:
	 map["lines"] = "1 rad"
      else:
	 map["lines"] = `map["lines"]` + " rader"
      marks = map["num_marks"]
      if marks == 0:
	 map["marks"] = ""
      elif marks == 1:
	 map["marks"] = "Markerad av en person<br>\n"
      else:
	 map["marks"] = "Markerad av " + `marks` + " personer<br>\n"

      # FIXME
      map["default_url"] = "<i>Default-URL</i>"


   def alt_conf(self):
      return "Olsta i mtet"

   def alt_comment(self):
      return "Kommentera"

   def alt_write_text(self):
      return "Skriva inlgg"

   def alt_next_conf(self):
      return "Nsta mte"

   def alt_see_time(self):
      return "Se tiden"
      
   def alt_home(self):
      return "Hem"

   def alt_kill(self):
      return "Logga ut"

   def alt_next_text(self):
      return "Nsta text"

   def alt_select_conf(self):
      return "Lista mten"

   def format_text(self, map):
      self.text_rewrite_map(map)
      return TEXT_FORMAT % map

   def info_unread_conf(self, conf, unread):
      return `unread` + " olsta i " + conf

   def info_unread_conf_many(self, conf):
      return "Mnga olsta i " + conf

   def there_are_more_unread_confs(self):
      return ("\n<p>\nDu har olsta inlgg i nnu fler mten. "
	      + "De kommer att visas nr du har lst ovanstende mten.")

   def login(self, unreadlist, trunc_msg):
      return self.page("Vlkommen", "Vlkommen till LysKOM!",
		       "Du r nu inloggad. "
		       + "Du har olsta inlgg i fljande mten:\n<p>\n"
		       + unreadlist
		       + trunc_msg)

   def unread_confs(self, unreadlist, trunc_msg):
      return self.page("Olsta mten", "Olsta mten",
		       "Du har olsta inlgg i fljande mten:\n<p>\n"
		       + unreadlist
		       + trunc_msg)

   def text_link(self, texturl, subject, prev_subject, author):
      if subject == prev_subject:
	 return texturl + " " + author
      else:
	 return texturl + " " + subject + "<br>\n" + author

   def different_passwords(self):
      return self.page("WWW-kom", "Kunde inte skapa person",
		       "Du angav tv olika lsenord.  Frsk igen.")

   def person_creation_failed(self, name):
      return self.page("WWW-kom", "Kunde inte skapa person",
		       "En person med namnet " + name + " kunde inte skapas.\n"
		       + "Kanske finns det redan ngon som heter s?\n\n"
		       + "<p>Frsk igen med ett annat namn.\n"
		       + "Du kan till exempel lgga till en initial "
		       + "eller namnet p din organisation.")

   def creation_done(self, name, pno):
      return self.page("WWW-kom", "Vlkommen",
		       "Vlkommen till LysKOM, " + komhtml.htmlquote(name)
		       + "!\nHoppas du ska trivas hr.\n"
		       + 'Nu mste du <a href="wwwkom/('
		       + `pno` + ')/login">logga in</a>. '
		       + "Din Web-klient kommer att be dig mata in det namn "
		       + "och lsenord som du just angav.\n"
		       + "(Du tycker kanske att det r dumt att du ska behva "
		       + "mata in de uppgifterna igen.  Tyvrr tvingar HTTP "
		       + "fram den hr lsningen).\n\n"
		       + "<p>Om du r den sifferlskande typen vill du kanske "
		       + "veta att ditt anvndarnummer r " + `pno`
		       + ".  Annars kan du strunta i det -- du kan alltid "
		       + "anvnda ditt namn och behver inte komma ihg det "
		       + "nummer som anvnds internt i LysKOM-systemet.")

   def write_comment(self, map):
      return self.page("Kommentera",
		       "Kommentera text " + `pickle.loads(map["parent"])`,
		       COMMENT_FORMAT % map)

   def write_text(self, map):
      return self.page("Skriva inlgg",
		       "Skriva inlgg i " + map["conf_name"],
		       WRITE_TEXT_FORMAT % map)

   def write_text_format_recipient(self, conf, conf_as_link, sequence):
      return ('<input type="checkbox" name="rcpt' + `sequence`
	      + '" value="' + pickle.dumps(conf) + '" checked> '
	      + conf_as_link + '<br>\n')

   def text_created(self, tno):
      return self.page("Text skapad", "Text " + `tno` + " skapad.",
		       "Text nummer " + komhtml.text_as_link(tno)
		       + " r nu skapad.")

   def new_texts_exists(self, new_texts, map):
      new_texts = string.join(new_texts, "\n<hr>\n")
      return self.page("Kommentera", "Nya kommentarer funna",
		       NEW_TEXTS_INFO + new_texts + NEW_TEXTS_INFO_TAIL
		       + (COMMENT_FORMAT % map))

   def killed(self):
      return self.page("Omstart", "Omstart", KILLED)

   def select_conf_form(self):
      return self.page("Lista mten", "Lista mten", SELECT_CONF_FORM)

   def list_conf(self, session, matches):
      # Fixme: kan vara personer...
      return self.page("Mten", "Mten",
		       "Fljande mten/personer matchar det du angav: <p>"
		       + self.list_conf_z_info(
			  matches, komhtml.komurl(session,
						  "conf_stat?conf_no=%s")))

   def conf_stat(self, session, map):
      return self.page(map["name"], map["name"], CONF_STAT % map)

lingo=sw_pages()
