# $Id: myhttpbase.py,v 1.2 1996/05/08 07:51:47 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import string
import komhtml
import SimpleHTTPServer
from language import lingo

class myhttpbase(SimpleHTTPServer.SimpleHTTPRequestHandler):

   def respond(self, body):
      self.send_response(200)
      self.send_header("Content-type", "text/html")
      self.end_headers()
      self.wfile.write(body)

   def bad_auth(self):
      self.send_response(401)
      self.send_header("WWW-Authenticate", 'Basic realm="LysKOM"')
      self.end_headers()

   def redirect(self, newsession):
      print "Redirect entered"
      newurl = komhtml.decodeurl(self.url.as_string_sans_hostpart())
      print "Setting session"
      newurl.pers_no = newsession
      print "As-string"
      urlstr = newurl.as_string()

      self.send_response(301)
      self.send_header("Location", urlstr)
      self.send_header("Content-type", "text/html")
      self.end_headers()
      self.wfile.write(lingo.session_redirect(urlstr))

   # Overridden since the default method didn't specify
   # the content-type of the message.
   def send_error(self, code, message=None):
      """Send and log an error reply.

      Arguments are the error code, and a detailed message.
      The detailed message defaults to the short entry matching the
      response code.

      This sends an error response (so it must be called before any
      output has been generated), logs the error, and finally sends
      a piece of HTML explaining the error to the user.

      """

      try:
	 short, long = self.responses[code]
      except KeyError:
	 short, long = '???', '???'
      if not message:
	 message = short
      explain = long
      self.log_error("code %d, message %s", code, message)
      self.send_response(code, message)
      self.send_header("Content-type", "text/html")
      self.end_headers()
      self.wfile.write(self.error_message_format %
		       {'code': code,
			'message': message,
			'explain': explain})
