# $Id: sc.py,v 1.11 1996/05/08 07:51:49 ceder Exp $
# Copyright (C) 1996  Per Cederqvist and Inge Wallin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import signal
import regsub
import pickle
import string
import base64
import toolbar
import komhtml
import komtext
import myserver
import myhttpbase
import komxx
import sys
import socket
import posix
import language
from language import lingo

session=None
true=1
false=0

system_error='system_error'
internal_error='internal_error'

class State:
   def __init__(self):
      self.password = None		# The correct password

state = State()

class sh(myhttpbase.myhttpbase):

   def send_response(self, code, message=None):
      "As myhttpbase.send_response, but adds an expired Expires field."
      myhttpbase.myhttpbase.send_response(self, code, message)
      self.send_header("Expires", self.date_time_string())
      self.reply_written = 1

   def prepare_request(self):
      global state
      self.reply_written = 0
      while session.handle_async(20) == komxx.st_pending:
	 print "Handling even more async..."
      self.url = komhtml.decodeurl(self.path)
      args = self.url.arglist
      auth = self.headers.getheader('Authorization')
      if not self.url.pers_no:
	 raise system_error, "no session in url"
      if auth == None:
	 raise system_error, "no auth provided"
      [scheme, cookie] = string.split(auth)
      if (string.lower(scheme) != "basic"):
	 raise system_error
      [user, password] = string.split(base64.decodestring(cookie), ":")
      print "session.my_login() is", session.my_login()
      sys.stdout.flush()
      if session.my_login() == 0:
	 # Not logged in.  Attempt to log in.
	 if state.password:
	    raise system_error, "password set in state"
	 if session.login(self.url.pers_no, password) == komxx.st_ok:
	    state.password = password
	 else:
	    raise komhtml.bad_auth
      else:
	 # Logged in.  Check password.
	 if self.url.pers_no != session.my_login():
	    raise system_error, "lm contacted wrong sc"
	 if password != state.password:
	    matches = session.lookup_z_name(user, true, false)
	    if len(matches) == 0:
	       raise komhtml.bad_auth
	    elif len(matches) == 1:
	       if self.url.pers_no == matches[0].conf_no():
		  raise komhtml.bad_auth
	       else:
		  self.redirect(matches[0].conf_no())
	    else:
	       self.respond(lingo.ambiguous_login(user, matches))
      # The user is authenticated.
      if session.my_login() == 0:
	 raise internal_error, "my_login() is 0 after successful login"

      # Initialize toolbar
      self.toolbar = toolbar.toolbar(session.my_login())

      # Transfer the toolbar into the language package.
      language.toolbar = self.toolbar
      komhtml.text_to_mark = None

      # Perform embedded commands
      read_text = self.url.getnum("is_read")
      if read_text:
	 print "EMBED: Removing text", read_text
	 session.remove_text(read_text)
	 text = komhtml.text(read_text)
	 text.mark_as_read()

   def do_GET(self):
      self.reply_written = 0
      signal.alarm(600)
      try:
	 try:
	    self.prepare_request()
	    mname = "kom_GET_" + self.url.cmd
	    try:
	       method = getattr(self, mname)
	    except AttributeError:
	       self.send_error(501)
	       return
	    method(self.url.arglist)
	 except komhtml.bad_auth:
	    self.bad_auth()
	 except komhtml.not_a_komurl, emsg:
	    self.send_error(500, emsg)
	 except internal_error, str:
	    self.send_error(500, "internal_error" + str)
	 # FIXME: a nicer error page, thanks.
	 except komxx.errno_error, err:
	    self.send_error(500, "During GET: unhandled LysKOM error "
			    + `err.errno` + " occured: " + err.errmsg)
      finally:
         if self.reply_written == 0:
	    print "No reply was sent; last error:"
	    sys.stdout.flush()
	    self.send_error(500, "Internal error: unexpected exception")
	    self.wfile.flush()
	    if sys.exc_type:
	       raise sys.exc_type, sys.exc_value, sys.exc_traceback

   def do_POST(self):
      signal.alarm(600)
      try:
	 self.prepare_request()
	 length = self.headers.getheader('Content-length')
	 if (self.headers.getheader('Content-type')
	     != "application/x-www-form-urlencoded"):
	    self.log_error("Bad content-type"
			   + self.headers.getheader('Content-type'))
	    self.send_error(400)
	    return
	 body = self.rfile.read(eval(length))
	 args = komhtml.form_data(body)
	 mname = "kom_POST_" + self.url.cmd
	 method = getattr(self, mname)
	 method(args)
      except komhtml.bad_auth:
	 self.bad_auth()
      except komhtml.not_a_komurl, emsg:
	 self.send_error(500, emsg)
      except internal_error, str:
	 self.send_error(500, "internal_error" + str)
      except komxx.errno_error, err:
	 self.send_error(500, "During POST: unhandled LysKOM error "
			 + `err.errno` + " occured: " + err.errmsg)

   def kom_GET_login(self, args, is_login=1):
      texts_in_conf=50
      confs=20
      while session.prefetch(0, 0, 0,
			     0, texts_in_conf, confs+1,
			     40) == komxx.st_pending:
	 session.block(1000)

      unread_list=session.confs_with_unread()
      trunc=""
      if len(unread_list) > confs:
	 unread_list[-1:]=[]
	 trunc=lingo.there_are_more_unread_confs()
      conflist=[]
      for unread in unread_list:
	 conf=('<a href="conf?conf_no=' + `unread[0]` + '">' +
	       komtext.safe_name_direct_conf(session, unread[0]) + '</a>')
	 min_unread=unread[1]
	 max_unread=unread[2]
	 if min_unread == max_unread:
	    conflist.append(lingo.info_unread_conf(conf, min_unread))
	 else:
	    conflist.append(lingo.info_unread_conf_many(conf))

      if len(unread_list) > 0:
	 self.toolbar.add_default_conf(unread_list[0][0])
      else:
	 self.toolbar.add_default_time()

      if is_login:
	 self.respond(lingo.login(string.join(conflist, "<br>\n"), trunc))
      else:
	 self.respond(lingo.unread_confs(string.join(conflist, "<br>\n"), 
					 trunc))

   def kom_GET_home(self, args):
      self.kom_GET_login(args, 0)

   def kom_GET_text(self, args):
      if not args.has_key("text_no"):
	 raise not_a_komurl
      try:
	 tno = string.atoi(args["text_no"])
      except ValueError:
	 raise not_a_komurl
      text=session.text(tno)
      try:
	 komhtml.text_to_mark = tno
	 komtext.prefetch_for_display(session, text)
	 map = komtext.map_for_display(session, text)
	 the_page = lingo.format_text(map)
	 self.toolbar.enable_bottom()
      except komxx.err_no_such_text:
	 the_page = lingo.nonexisting_text_long()
      # FIXME: always know it (maybe as an embedded cmd)
      if session.current_conf() != 0:
	 self.toolbar.add_current_conf(session.current_conf())
      self.toolbar.add_comment(tno)
      if session.current_conf() != 0:
	 self.toolbar.add_write(session.current_conf())
      session.remove_text(tno)
      self.fix_default()
      self.respond(lingo.page("Text " + `tno`, "Text " + `tno`, the_page))

   def fix_default(self):
      prompt = session.next_prompt()
      while prompt == 6:
	 prompt = session.next_prompt()
      if prompt == 1:
	 # Next conf
	 session.goto_next_conf()
	 self.toolbar.add_default_conf(session.current_conf())
      elif prompt == 2 or prompt == 3 or prompt == 4:
	 # Next text/comment/footnote
	 self.toolbar.add_default_text(session.next_text())
      elif prompt == 5:
	 self.toolbar.add_default_time()
      else:
	 self.toolbar.add_kill()

   def kom_GET_conf(self, args):
      if not args.has_key("conf_no"):
	 raise not_a_komurl
      try:
	 cno = string.atoi(args["conf_no"])
      except ValueError:
	 raise not_a_komurl
      conf=session.conf(cno)
      print "Gr till mtet"
      sys.stdout.flush()
      if session.goto_conf(cno) != komxx.st_ok:
	 raise not_a_komurl, "Couldn't go to the conf"
      print "Har gtt till mtet"
      sys.stdout.flush()

      # Prefetch information for the list.
      unread_list = ""
      unread=session.list_unread_texts_in_current(20)
      unprefetched_authors=[]
      for (text, level) in unread:
	 komtext.prefetch_author(session, session.text(text),
				 unprefetched_authors)
      for t in unprefetched_authors:
	 if t.exists():
	    session.conf(t.author()).prefetch_name()
	    
      # Format the list of unread texts.
      prev_level = -1
      prev_subject = ""
      for (text, level) in unread:
	 while prev_level < level:
	    prev_level = prev_level + 1
	    unread_list = unread_list + "<ul>\n"
	 while prev_level > level:
	    prev_level = prev_level - 1
	    unread_list = unread_list + "</ul>\n"
	 t = session.text(text)
	 subject = t.subject()
	 unread_list = unread_list + "<li>" + lingo.text_link(
	    komhtml.text_as_link(text),
	    subject, prev_subject, komtext.safe_author(session, text))
	 prev_subject = subject
      while prev_level > -1:
	 prev_level = prev_level - 1
	 unread_list = unread_list + "</ul>\n"
      self.fix_default()
      self.toolbar.add_write(cno)
      self.respond(lingo.page("Olsta",
			      "Olsta i " + komtext.safe_name(session, cno),
			      "Dessa texter r olsta: " + unread_list))

   def kom_GET_comment(self, args):
      if not args.has_key("parent"):
	 raise not_a_komurl
      try:
	 tno = string.atoi(args["parent"])
      except ValueError:
	 raise not_a_komurl
      text=session.text(tno)
      text.prefetch()
      #
      # Prefetch everything needed to comment text TEXT
      #
      author=session.conf(text.author())
      author.prefetch_name()
      for rcpt in text.recipients():
	 if not rcpt.is_carbon_copy():
	    session.conf(rcpt.recipient()).prefetch()
      #
      # Prepare the page
      #
      map = komtext.create_comment_map(session, tno)
      if session.current_conf() != 0:
	 self.toolbar.add_current_conf(session.current_conf())
	 self.toolbar.add_write(session.current_conf())
      self.respond(lingo.write_comment(map))

   def kom_GET_submit_comment(self, args):
      #
      # This method is called when the user submitts a comment.
      #
      i = pickle.loads(args["no_of_rcpts"])
      recipients=[]
      while i > 0:
	 i = i - 1
	 if args.has_key("rcpt" + `i`):
	    recipients.append(pickle.loads(args["rcpt" + `i`]))
      comment_to = pickle.loads(args["parent"])
      t = session.text(comment_to)
      comments = pickle.loads(args["known_comments"])
      new_comments = []
      current_comments = t.comments_in() + t.footnotes_in()
      for c in current_comments:
	 if c not in comments and c not in new_comments:
	    new_comments.append(c)
      print "COMMENTS: old:", comments, "current:", current_comments,
      print "new:", new_comments
      sys.stdout.flush()
      if len(new_comments) > 0:
	 new_comments.sort()
	 for c in new_comments:
	    komtext.prefetch_for_display(session, session.text(c))
	 new_texts=[]
	 for c in new_comments:
	    map = komtext.map_for_display(session, session.text(c))
	    new_texts.append(lingo.format_text(map))
	 map = komtext.recreate_comment_map(
	    session, args, current_comments, recipients)
	 self.respond(lingo.new_texts_exists(new_texts, map))
      else:
	 # FIXME: Introduce a "get_if_exists_otherwise_empty"
	 # method in the base instead.
	 if args.has_key("body"):
	    body = regsub.gsub('\r', ' ', args["body"])
	 else:
	    body = ""
	 if args.has_key("subject"):
	    subject = args["subject"]
	 else:
	    subject = ""
	 if args.has_key("conversion"):
	    body = do_convert(args["conversion"], body)
	    subject = do_convert(args["conversion"], subject)

	 tno = session.create_text(subject, body, recipients,
				   [], [comment_to], [])
	 self.fix_default()
	 self.respond(lingo.text_created(tno))

   def kom_GET_write_text(self, args):
      try:
	 cno = string.atoi(args["conf_no"])
      except ValueError:
	 raise not_a_komurl
      conf=session.conf(cno)
      conf.prefetch()
      #
      # Prepare the page
      #
      map = komtext.create_text_map(session, [cno])
      self.toolbar.add_default_conf(cno)
      self.respond(lingo.write_text(map))

   def kom_GET_submit_text(self, args):
      i = pickle.loads(args["no_of_rcpts"])
      recipients=[]
      while i > 0:
	 i = i - 1
	 if args.has_key("rcpt" + `i`):
	    recipients.append(pickle.loads(args["rcpt" + `i`]))
      body = regsub.gsub('\r', ' ', args["body"])
      subject = args["subject"]
      if args.has_key("conversion"):
	 body = do_convert(args["conversion"], body)
	 subject = do_convert(args["conversion"], subject)

      tno = session.create_text(subject, body, recipients, [], [], [])
      self.fix_default()
      self.respond(lingo.text_created(tno))

   def kom_GET_kill(self, args):
      self.respond(lingo.killed())
      sys.stdout.flush()
      sys.stderr.flush()
      self.wfile.flush()
      signal.alarm(1)

   def kom_GET_select_conf_form(self, args):
      self.respond(lingo.select_conf_form())

   def kom_GET_submit_select_conf(self, args):
      domain = args["domain"]
      search_conf = 0
      search_pers = 0
      if domain == "conf":
	 search_conf = 1
      elif domain == "pers":
	 search_pers = 1
      elif domain == "both":
	 search_conf = 1
	 search_pers = 1
      matches = session.lookup_z_name(args["conf_name"], 
				      search_pers, search_conf)
      if len(matches) == 1:
	 print "Matches 0:", matches[0]
	 return self.kom_GET_conf_stat({"conf_no": `matches[0].conf_no()`})
      else:
	 self.respond(lingo.list_conf(session.my_login(), matches))

   def kom_GET_conf_stat(self, args):
      try:
	 cno = string.atoi(args["conf_no"])
      except ValueError:
	 raise not_a_komurl
      conf = session.conf(cno)
      map = {}
      map["name"] = komtext.safe_name(session, cno)
      #FIXME: Skapare kan vara person 0
      map["creator"] = komtext.safe_name(session, conf.creator())
      map["supervisor"] = komtext.safe_name(session, conf.supervisor())
      if conf.permitted_submitters() == 0:
	 psub = "Alla"
      else:
	 psub = ("Medlemmar i" 
		 + komtext.safe_name(session, conf.permitted_submitters()))
      map["permitted_submitters"] = psub
      map["presentation"] = komhtml.text_as_link(conf.presentation())
      map["join"] = komhtml.komurl(session.my_login(), 
				   "join?conf_no=" + `cno`)
      map["write_text"] = komhtml.komurl(session.my_login(), 
					 "write_text?conf_no=" + `cno`)
      self.toolbar.add_current_conf(cno)
      self.toolbar.add_write(cno)
      self.respond(lingo.conf_stat(session.my_login(), map))

   def kom_GET_join(self, args):
      try:
	 cno = string.atoi(args["conf_no"])
      except ValueError:
	 raise not_a_komurl
      session.join_conference(cno, 100, 100)
      self.kom_GET_conf(args)

   def kom_GET_who_is_on(self, args):
      try:
	  wholist = session.who_is_on()
      except ValueError:
	 raise not_a_komurl
      wholist.reverse()

      # Prefetch the name for the person and his working conference
      for w in wholist:
	  session.conf(w[0]).prefetch_name()
	  session.conf(w[1]).prefetch_name()

      wholist2 = []
      for w in wholist:
	  persname = komtext.safe_name(session, w[0])
	  perslink = komhtml.conf_as_link(w[0], persname, session.my_login())
	  if w[1] == 0:
	      confname = lingo.not_present()
	  else:
	      confname = komtext.safe_name(session, w[1])

	  if w[2] == session.my_session():
	      item = ("<tr valign=top>" 
		      + "<td><b>" + `w[2]` 
		      + "</b><td><b>" + perslink
		      + "</b><td><b>" + confname
		      + "</b></tr>")
	  else:
	      item = ("<tr valign=top>" 
		      + "<td>" + `w[2]` 
		      + "<td>" + perslink
		      + "<td>" + confname
		      + "</tr>")
	  wholist2.append(item)

      self.respond(lingo.who_is_on(wholist2))


def do_convert(conversion, str):
   if conversion == "swascii":
      str = regsub.gsub('}', '', str)
      str = regsub.gsub('{', '', str)
      str = regsub.gsub('|', '', str)
      str = regsub.gsub(']', '', str)
      str = regsub.gsub('\[', '', str)
      str = regsub.gsub('\\\\', '', str)
   return str

def start_httpd():
   for port in range(8000, 8500):
      try:
	 httpd = myserver.myserver(('', port), sh)
	 print "WWW-kom", port
	 sys.stdout.flush()
	 f=open("/tmp/wwwkomserver." + `posix.getpid()` + ".out", "w")
	 posix.dup2(f.fileno(), 0)
	 posix.dup2(f.fileno(), 1)
	 posix.dup2(f.fileno(), 2)
	 break
      except socket.error:
	 # Try next port in the range
	 pass
   return httpd

def test():
   global session
   httpd = start_httpd()
   session = komxx.new_session(sys.argv[1], sys.argv[2])
   httpd.serve_forever()

if __name__ == '__main__':
   test()
